<?php
/**
* @version      $Id: currency_exchange_loader.php v 1.1
* @package      Currency Exchange Informer
* @copyright    Copyright (C) 2009 FalsinSoft. All rights reserved.
* @license      GNU/GPL
* @website      http://www.falsinsoft.co.nr
* @email        falsinsoft@gmail.com
* 
*/

$joomla_base_path = dirname(__FILE__);

$pos = strrpos($joomla_base_path, "modules");

if($pos === false) 
{
	echo 'E1';
	return;
}

$joomla_base_path = substr($joomla_base_path, 0, $pos-1);

define('_JEXEC', 1);
define('JPATH_BASE', $joomla_base_path);
define('DS', DIRECTORY_SEPARATOR);
                                                      
require_once(JPATH_BASE.DS.'includes'.DS.'defines.php');
require_once(JPATH_BASE.DS.'includes'.DS.'framework.php');

$mainframe =& JFactory::getApplication('site');

$currencies_list = array("ANG","VEF","BHD","NPR","XOF","JMD","ILS","OMR","NAD","DZD","ISK","AUD","HNL","SKK","RON","TND","EUR","JOD","IDR","KES","SEK","MDL","QAR","PKR","BDT","CAD","BOB","BND","TRY","SLL","MKD","BWP","MXN","PEN","DOP","NZD","TZS","LTL","NOK","KRW","RUB","CHF","DKK","ARS","NIO","CZK","KYD","FJD","MVR","SAR","PHP","ZMK","CNY","LBP","LKR","GBP","UYU","TTD","LVL","VND","NGN","RSD","HKD","EGP","CRC","USD","COP","PYG","UZS","INR","YER","JPY","KWD","KZT","HUF","SCR","MUR","BGN","MYR","AED","UGX","EEK","UAH","THB","ZAR","PGK","TWD","CLP","MAD","SVC","PLN","SGD","BRL","HRK");

if(!isset($_GET['base'])
|| !isset($_GET['converted'])
|| !isset($_GET['rand']))
{
	echo 'E2';
    return;
}

$currency_base      = JRequest::getString('base');
$currency_converted = JRequest::getString('converted');

if(!in_array($currency_base, $currencies_list)
|| !in_array($currency_converted, $currencies_list)
|| $currency_base == $currency_converted)
{
	echo 'E3';
    return;
}

$converter_url = "http://finance.google.com/finance/converter?a=1&from=".$currency_base."&to=".$currency_converted;

$page_html = "";

$page_handle = fopen($converter_url, "r");
while(!feof($page_handle)) $page_html .= fread($page_handle, 4096);
fclose($page_handle);

$pos1 = strpos($page_html, "currency_converter_result");

if($pos1 === false)
{
	echo 'E4';
    return;
}

$pos2 = strpos($page_html, $currency_converted."</span>", $pos1);

if($pos2 === false)
{
	echo 'E5';
    return;
}

$page_html = substr($page_html, $pos1, $pos2-$pos1-1);

$pos1 = strrpos($page_html, ">");

if($pos1 === false)
{
	echo 'E6';
    return;
}

$exchange_rate = substr($page_html, $pos1+1);

if(floatval($exchange_rate) == 0)
{
	echo 'E7';
    return;
}

$session =& JFactory::getSession();
$session->set('CEI_'.$currency_base.'_'.$currency_converted, floatval($exchange_rate));
$session->set('CEI_LOADING_TIME', time());

echo $exchange_rate;

?>
